diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
index 0ece7c0cc..783b8737d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeSwamp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeSwamp.java
@@ -1,6 +1,7 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShapeSwamp;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
index be0f34a9a..b27ab4794 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTaiga.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/BiomeTaiga.java
@@ -1,8 +1,9 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.overworld;
 
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaTall;
 import net.minecraft.core.world.generate.feature.WorldFeature;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeParadise.java b/game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/world/biome/BiomeParadise.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java
index 2a21492b6..dbd136566 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java
@@ -1,7 +1,8 @@
-package net.minecraft.core.world.biome;
+package net.minecraft.core.world.biome.paradise;
 
 import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.biome.Biome;
 
 public class BiomeParadise extends Biome
 {	
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
new file mode 100644
index 000000000..db17755be
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -0,0 +1,277 @@
+package net.minecraft.core.world.biome.provider;
+
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.type.WorldTypes;
+
+import java.util.Arrays;
+import java.util.Random;
+
+public final class BiomeProviderNether
+    extends BiomeProvider
+{
+    public static class BiomeOverlapPair {
+        public boolean hasOverlap;
+        public Biome biomeA;
+        public Biome biomeB;
+        public float biomeAPercentage;
+        public float biomeBPercentage;
+    }
+
+    private static final Biome[] biomesOrder = {
+            Biomes.NETHER_BONEYARD,
+            Biomes.NETHER_ASH_PLAINS,
+            Biomes.NETHER_CRYSTAL_FOREST,
+            Biomes.NETHER_SULFUR_POOLS,
+            Biomes.NETHER_NETHER,
+            Biomes.NETHER_VOLCANIC_ISLANDS
+    };
+
+    private final PerlinSimplexNoise temperatureNoise;
+    private final PerlinSimplexNoise fuzzinessNoise;
+
+    private double temperatureXScale = 0.0125;
+    private double temperatureZScale = 0.0125;
+    private double temperatureExponent = 0.25;
+    private double temperatureFuzzPercentage = 0.01;
+
+    private double fuzzinessXScale = 0.25;
+    private double fuzzinessZScale = 0.25;
+    private double fuzzinessExponent = 1.0;
+
+    public BiomeProviderNether(long seed)
+    {
+        this.temperatureNoise = new PerlinSimplexNoise(new Random(seed * 5345L), 4);
+
+        this.fuzzinessNoise = new PerlinSimplexNoise(new Random(seed * 35864L), 2);
+    }
+
+    @Override
+    public Biome[] getBiomes(Biome[] biomes, double[] temperatures, double[] humidities, double[] varieties, int x, int y, int z, int xSize, int ySize, int zSize) {
+        if (biomes == null || biomes.length < xSize * ySize * zSize)
+        {
+            biomes = new Biome[xSize * ySize * zSize];
+        }
+        if (temperatures == null || temperatures.length < xSize * zSize)
+        {
+            temperatures = getTemperatures(temperatures, x, z, xSize, zSize);
+        }
+        if (humidities == null || humidities.length < xSize * zSize)
+        {
+            humidities = getHumidities(humidities, x, z, xSize, zSize);
+        }
+        if (varieties == null || varieties.length < xSize * zSize)
+        {
+            varieties = getVarieties(varieties, x, z, xSize, zSize);
+        }
+
+        for (int dx = 0; dx < xSize; dx++)
+        {
+            for (int dz = 0; dz < zSize; dz++)
+            {
+                double temperature = temperatures[dx * zSize + dz];
+                double humidity = humidities[dx * zSize + dz];
+                double variety = varieties[dx * zSize + dz];
+
+                for (int dy = 0; dy < ySize; dy++)
+                {
+                    double altitude = WorldTypes.NETHER_DEFAULT.getYPercentage((y + dy) << 3);
+                    biomes[dy * xSize * zSize + dz * xSize + dx] = lookupBiome(temperature, humidity, altitude, variety);
+                }
+            }
+        }
+
+        return biomes;
+
+    }
+
+    public double getTemperature(double x, double z) {
+        double[] tnResult = temperatureNoise.getValue(null, x, z, 1, 1, temperatureXScale, temperatureZScale, temperatureExponent);
+        double[] fnResult = fuzzinessNoise.getValue(null, x, z, 1, 1, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+
+        double fuzziness = fnResult[0] * 1.1 + 0.5;
+
+        double fuzzPctg = temperatureFuzzPercentage;
+        double valPctg = 1.0 - fuzzPctg;
+        double temperature = (tnResult[0] * 0.15 + 0.7) * valPctg + fuzziness * fuzzPctg;
+
+        if (temperature < 0.0)
+        {
+            temperature = 0.0;
+        }
+        if (temperature > 1.0)
+        {
+            temperature = 1.0;
+        }
+
+        return temperature;
+    }
+
+    @Override
+    public double[] getTemperatures(double[] temperatures, int x, int z, int xSize, int zSize) {
+        if (temperatures == null || temperatures.length < xSize * zSize)
+        {
+            temperatures = new double[xSize * zSize];
+        }
+
+        double[] tnResult = temperatureNoise.getValue(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
+        double[] fnResult = fuzzinessNoise.getValue(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+
+        for (int dx = 0; dx < xSize; dx++)
+        {
+            for (int dz = 0; dz < zSize; dz++)
+            {
+                double fuzziness = fnResult[dx * zSize + dz] * 1.1 + 0.5;
+
+                double fuzzPctg = temperatureFuzzPercentage;
+                double valPctg = 1.0 - fuzzPctg;
+                double temperature = (tnResult[dx * zSize + dz] * 0.15 + 0.7) * valPctg + fuzziness * fuzzPctg;
+
+                if (temperature < 0.0)
+                {
+                    temperature = 0.0;
+                }
+                if (temperature > 1.0)
+                {
+                    temperature = 1.0;
+                }
+
+                temperatures[dx * zSize + dz] = temperature;
+            }
+        }
+
+        return temperatures;
+    }
+
+    @Override
+    public double[] getHumidities(double[] humidities, int x, int z, int xSize, int zSize) {
+        if (humidities == null || humidities.length < xSize * zSize)
+        {
+            humidities = new double[xSize * zSize];
+        }
+
+        return humidities;
+    }
+
+    @Override
+    public double[] getVarieties(double[] varieties, int x, int z, int xSize, int zSize) {
+        if (varieties == null || varieties.length < xSize * zSize)
+        {
+            varieties = new double[xSize * zSize];
+        }
+
+        return varieties;
+    }
+
+    @Override
+    public double[] getBiomenesses(double[] biomenesses, int x, int y, int z, int xSize, int ySize, int zSize) {
+        if (biomenesses == null || biomenesses.length < xSize * ySize * zSize)
+        {
+            biomenesses = new double[xSize * ySize * zSize];
+        }
+
+        Arrays.fill(biomenesses, 1.0f);
+
+        return biomenesses;
+    }
+
+    @Override
+    public Biome lookupBiome(double temperature, double humidity, double altitude, double variety) {
+        for (int i = 0; i < biomesOrder.length; i++) {
+            if (temperature <= (1.0 / biomesOrder.length) * (i + 1)) {
+                return biomesOrder[i];
+            }
+        }
+
+        return Biomes.NETHER_NETHER;
+    }
+
+    public void getOverlap(double temperature, BiomeOverlapPair toUpdate) {
+        final float overlapAmount = 1f / (float)(biomesOrder.length * 4);
+
+        for (int i = 0; i < biomesOrder.length; i++) {
+            // The *strict* bounds of the biome, as used by this::lookupBiome()
+            final float minStrict = (1.0f / biomesOrder.length) * i;
+            final float maxStrict = (1.0f / biomesOrder.length) * (i + 1);
+            // The outer bounds of the biome, i.e. strict bounds plus overlap amount. If in this range, guaranteed overlap
+            final float minOuter = minStrict - overlapAmount;
+            final float maxOuter = maxStrict + overlapAmount;
+            // The inner bounds of the biome, i.e. strict bounds minus overlap amount. If in this range, guaranteed no overlap
+            final float minInner = minStrict + overlapAmount;
+            final float maxInner = maxStrict - overlapAmount;
+
+            // Edge cases
+            if ((i == 0 && temperature < minInner) ||
+                (i == biomesOrder.length - 1 && temperature >= maxInner)
+            ) {
+                toUpdate.hasOverlap = false;
+                toUpdate.biomeA = biomesOrder[i];
+                toUpdate.biomeAPercentage = 1.0f;
+                return;
+            }
+
+            // Check if in inner bounds
+            if (temperature >= minInner && temperature < maxInner) {
+                // In inner bounds - only one biome is present here
+                toUpdate.hasOverlap = false;
+                toUpdate.biomeA = biomesOrder[i];
+                toUpdate.biomeAPercentage = 1.0f;
+                return;
+            }
+
+            // Check if in outer bounds
+            if (temperature >= minOuter && temperature < maxOuter) {
+                // Check if in min outer bound
+                if (temperature < minInner) {
+                    toUpdate.hasOverlap = true;
+
+                    // Define biomes
+                    toUpdate.biomeA = biomesOrder[i - 1];
+                    toUpdate.biomeB = biomesOrder[i];
+
+                    // Define percentages
+                    final float range = minInner - minOuter;
+                    // minOuter <= temperature < minInner
+                    temperature -= minOuter; // 0 <= temperature < range
+                    temperature /= range; // 0 <= temperature < 1
+
+                    // Biome A goes to 0.0 as temperature goes to 1.0
+                    // Biome B goes to 1.0 as temperature goes to 1.0
+                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
+                    toUpdate.biomeBPercentage = (float) temperature;
+
+                    return;
+                }
+
+                // Check if in max outer bound
+                if (temperature >= maxInner) {
+                    toUpdate.hasOverlap = true;
+
+                    // Define biomes
+                    toUpdate.biomeA = biomesOrder[i];
+                    toUpdate.biomeB = biomesOrder[i + 1];
+
+                    // Define percentages
+                    final float range = maxOuter - maxInner;
+                    // maxInner <= temperature < maxOuter
+                    temperature -= maxInner; // 0 <= temperature < range
+                    temperature /= range; // 0 <= temperature < 1
+
+                    // Biome A goes to 0.0 as temperature goes to 1.0
+                    // Biome B goes to 1.0 as temperature goes to 1.0
+                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
+                    toUpdate.biomeBPercentage = (float) temperature;
+
+                    return;
+                }
+            }
+        }
+
+        // We should never get here!
+        toUpdate.hasOverlap = false;
+        toUpdate.biomeA = Biomes.NETHER_NETHER;
+        toUpdate.biomeAPercentage = 1.0f;
+        return;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java
new file mode 100644
index 000000000..4627c0df3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java
@@ -0,0 +1,176 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+import java.util.Random;
+
+public class NetherBonesLargeFeature extends LargeFeature {
+    private final int minY;
+    private final int maxY;
+
+    public NetherBonesLargeFeature() {
+        minY = 0;
+        maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+    }
+
+    public NetherBonesLargeFeature(int minY, int maxY) {
+        this.minY = minY;
+        this.maxY = maxY;
+    }
+
+    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    }
+
+    protected void generateCave(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+                                double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
+                                double heightMod) {
+        double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
+        double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
+        float rotHorOffset = 0.0F;
+        float rotVerOffset = 0.0F;
+        Random random = new Random(seed);
+        if (endPos <= 0) {
+            int maxLength = radiusChunk * 16 - 16;
+            endPos = maxLength - random.nextInt(maxLength / 4);
+        }
+        boolean noBranches = false;
+        if (startPos == -1) {
+            startPos = endPos / 2;
+            noBranches = true;
+        }
+        boolean reversed = random.nextBoolean();
+        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
+        for (; startPos < endPos; startPos++) {
+            double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
+            double height = width * heightMod;
+            float xzScale = MathHelper.cos(xRot);
+            float xOffset = MathHelper.sin(xRot);
+            blockX += xOffset;
+            blockY -= MathHelper.cos(yRot) * xzScale;
+            if (reversed) {
+                blockZ -= MathHelper.sin(yRot) * xzScale;
+            } else {
+                blockZ += MathHelper.sin(yRot) * xzScale;
+            }
+            yRot *= 0.92F;
+            xRot += rotVerOffset * 0.1F;
+            yRot += rotHorOffset * 0.1F;
+            rotVerOffset *= 0.75F;
+            rotHorOffset *= 0.9F;
+//            rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
+//            rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
+
+            // Do adjacent branches if necessary
+            if (false && !noBranches && startPos == branchPos && initialRadius > 1.0F) {
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                return;
+            }
+
+            // Check if we've gone far enough, and stop if so
+            double dxFromMiddle = blockX - chunkMiddleX;
+            double dzFromMiddle = blockZ - chunkMiddleZ;
+            double length = endPos - startPos;
+            double maxRadius = initialRadius + 2.0F + 16F;
+            if ((dxFromMiddle * dxFromMiddle + dzFromMiddle * dzFromMiddle) - length * length > maxRadius * maxRadius) {
+                return;
+            }
+            if (blockX < chunkMiddleX - Chunk.CHUNK_SIZE_X - width * 2D || blockZ < chunkMiddleZ - Chunk.CHUNK_SIZE_Z - width * 2D || blockX > chunkMiddleX + Chunk.CHUNK_SIZE_X + width * 2D || blockZ > chunkMiddleZ + Chunk.CHUNK_SIZE_Z + width * 2D) {
+                continue;
+            }
+
+            // Determine sizes of current section
+            int minX = MathHelper.floor(blockX - width) - baseChunkX * Chunk.CHUNK_SIZE_X - 1;
+            int maxX = (MathHelper.floor(blockX + width) - baseChunkX * Chunk.CHUNK_SIZE_X) + 1;
+            int minY = MathHelper.floor(blockY - height) - 1;
+            int maxY = MathHelper.floor(blockY + height) + 1;
+            int minZ = MathHelper.floor(blockZ - width) - baseChunkZ * Chunk.CHUNK_SIZE_Z - 1;
+            int maxZ = (MathHelper.floor(blockZ + width) - baseChunkZ * Chunk.CHUNK_SIZE_Z) + 1;
+            if (minX < 0) {
+                minX = 0;
+            }
+            if (maxX > Chunk.CHUNK_SIZE_X) {
+                maxX = Chunk.CHUNK_SIZE_X;
+            }
+            if (minY < this.minY + 1) {
+                minY = this.minY + 1;
+            }
+            if (maxY > this.maxY - (ChunkSection.SECTION_SIZE_Y / 2)) {
+                maxY = this.maxY - (ChunkSection.SECTION_SIZE_Y / 2);
+            }
+            if (minZ < 0) {
+                minZ = 0;
+            }
+            if (maxZ > Chunk.CHUNK_SIZE_Z) {
+                maxZ = Chunk.CHUNK_SIZE_Z;
+            }
+
+            // Place blocks in section
+            for (int x = minX; x < maxX; x++) {
+                double xPercentage = (((x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
+                zLabel:
+                for (int z = minZ; z < maxZ; z++) {
+                    double zPercentage = (((z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
+                    int yIndex = maxY;
+                    if (xPercentage * xPercentage + zPercentage * zPercentage >= 1.0D) {
+                        continue;
+                    }
+                    int y = maxY - 1;
+                    do {
+                        if (y < minY) {
+                            continue zLabel;
+                        }
+                        double yPercentage = ((y + 0.5D) - blockY) / height;
+                        if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
+                            int blockId = result.getBlock(x, yIndex, z);
+                            if (blockId == 0) {
+                                result.setBlock(x, yIndex, z, Blocks.BONESHALE.id());
+                            }
+                        }
+                        yIndex--;
+                        y--;
+                    } while (true);
+                }
+            }
+
+            if (noBranches) {
+                break;
+            }
+        }
+    }
+
+    @Override
+    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
+        if (world.getBlockBiome(chunkX * Chunk.CHUNK_SIZE_X, 0, chunkZ * Chunk.CHUNK_SIZE_Z) != Biomes.NETHER_BONEYARD) {
+            return;
+        }
+
+        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(10) + 1) + 1);
+//        if (rand.nextInt(12) != 0) {
+//            cavesToGenerate = 0;
+//        }
+
+        final int yRange = maxY - minY;
+
+        for (int i = 0; i < cavesToGenerate; i++) {
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + rand.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = minY + rand.nextInt(rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + rand.nextInt(Chunk.CHUNK_SIZE_Z);
+
+            float yRot = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+            float xRot = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+            float initialRadius = rand.nextFloat() + rand.nextFloat(); // 0 - 3
+            generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
index d2eb8aa71..404380849 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGenerator.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.world.generate.chunk;
 
+import com.mojang.logging.CategorizedLogger;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import org.slf4j.Logger;
 
 import static net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_X;
 import static net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_Z;
@@ -18,6 +21,8 @@ import static net.minecraft.core.world.chunk.ChunkSection.SECTION_SIZE_Y;
  */
 public abstract class ChunkGenerator
 {
+    private static final CategorizedLogger LOGGER = LogUtils.getLogger();
+
     protected final World world;
     private final ChunkDecorator decorator;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
index 11954ff36..95f030f9d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/TerrainGeneratorLerp.java
@@ -18,7 +18,7 @@ public abstract class TerrainGeneratorLerp
         this.rand = new Random();
     }
 
-    protected abstract int getBlockAt(int x, int y, int z, double density);
+    protected abstract int getBlockAt(Chunk chunk, int x, int y, int z, double density);
 
     @Override
     public ChunkGeneratorResult generateTerrain(Chunk chunk, double[] densityMap)
@@ -127,7 +127,7 @@ public abstract class TerrainGeneratorLerp
                                 int blockY = yInBlob + blobY * yBlocksPerBlob + world.worldType.getMinY();
                                 int blockZ = zInBlob + blobZ * zBlocksPerBlob;
 
-                                int id = getBlockAt(blockX, blockY, blockZ, zLerpDensity);
+                                int id = getBlockAt(chunk, blockX, blockY, blockZ, zLerpDensity);
 
                                 result.setBlock(blockX, blockY, blockZ, id);
 
